//
// Palette class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_PALETTE_H
#define __PTC_PALETTE_H

// include files
#include "Types.h"




class Palette
{
    public:

        // setup
        Palette();
        Palette(const Palette &other);
        ~Palette();

        // load palette data
        void load(const int32 data[]);

        // save palette data
        void save(int32 data[]) const;
        
        // get palette data
        const int32* data() const;

        // operators
        Palette& operator =(const Palette &other);
        bool operator ==(const Palette &other) const;
        bool operator !=(const Palette &other) const;

    private:

        // palette data
        int32 m_data[256];
};




#endif
