//
// Palette class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_PALETTE_H
#define __PTC_PALETTE_H

// include files
#include "Types.h"
#include "Copy.h"
extern "C" {
#include "Hermes/Hermes.h"
}


class Palette
{
    public:

        // setup
        Palette();
        Palette(const Palette &other);
        ~Palette();

        // memory access
        int32* lock();
        void unlock();

        // load palette data
        void load(const int32 data[]);

        // save palette data
        void save(int32 data[]) const;
        
        // get palette data
        const int32* data() const;

        // operators
        Palette& operator =(const Palette &other);
        bool operator ==(const Palette &other) const;
        bool operator !=(const Palette &other) const;

    private:

        // locked flag
        bool m_locked;
	
        HermesHandle m_handle;
        friend void Copy::palette(const Palette&,const Palette&);
};




#endif
