//
// Core Clear class for PTC 2.0 C++ API
// Copyright (c) 1998 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
//

#ifndef __PTC_CORE_CLEAR_H
#define __PTC_CORE_CLEAR_H

// include files
#include "Base/Color.h"
#include "Core/Index.h"
#include "Core/Format.h"




namespace ptc
{
    namespace Core
    {
        class Clear
        {
            public:

                // request clear
                void request(const Base::Format &format);
        
                // clear pixels
                void clear(void *pixels,int x,int y,int width,int height,int pitch,const Base::Color &color);

            private:
        
                // data
                Core::Format m_format;
        };
    }
}




#endif
