//
// Win32 Monitor class for OpenPTC 1.0 C++ Implementation
// Copyright (c) 1999 Glenn Fiedler (ptc@gaffer.org)
// This source code is licensed under the GNU LGPL
// See http://www.gnu.org/copyleft/lgpl.html for details
//

// include files
#include "Win32/Monitor.h"




Win32Monitor::Win32Monitor()
{
    // initialize critical section
    InitializeCriticalSection(&m_handle);
}


Win32Monitor::~Win32Monitor()
{
    // delete critical section
    DeleteCriticalSection(&m_handle);
}




void Win32Monitor::enter()
{
    // enter critical section
    EnterCriticalSection(&m_handle);
}


void Win32Monitor::leave()
{
    // leave critical section
    LeaveCriticalSection(&m_handle);
}
